//+------------------------------------------------------------------+
//|                                             Brooky_Wpr_Shade.mq4 |
//|                     Copyright  2010, www.Brooky-Indicators.com. |
//|                             http://www.www.Brooky-Indicators.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, www.Brooky-Indicators.com."
#property link      "http://www.www.Brooky-Indicators.com"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 SteelBlue
#property indicator_color2 OrangeRed
#property indicator_color3 EMPTY
#property indicator_color4 Black
#property indicator_color5 Lime

#property indicator_width1 5
#property indicator_width2 5
#property indicator_width3 5
#property indicator_width4 2
#property indicator_width5 2

#property indicator_minimum -100
#property indicator_maximum 0

#import "user32.dll"
   int GetDC(int hwnd);
   int ReleaseDC(int hwnd,int hdc);
#import "gdi32.dll"
   color GetPixel(int hdc,int x,int y);

//---- input parameters
extern string TimeFrame       = "Current time frame";
extern string Hello_From = "+www.Brooky-Indicators.com+";
extern string NOTE  = "+--DLL Must Be Allowed--+";
extern string NOTE2 = "+--For Auto Clear Backgound--+";
extern string settings = "+--Select Period & Levels--+";
extern int    Wpr_Period=14;
extern int    OBought=-40;
extern int    OSold  =-60;
extern int    Smooth_Period  =24;
extern string colors = "+--Select Colors for Levels--+";
extern color  oblevel = Blue;
extern color  oslevel = Red;
//---- buffers
double Wprbuff[];

double obbuff[];

double osbuff[];

double blankbuff[];

double smooth[];

string indicatorFileName;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   

   SetIndexBuffer(0,obbuff);SetIndexStyle(0,DRAW_HISTOGRAM);SetIndexDrawBegin(0,Wpr_Period);
   
   SetIndexBuffer(1,osbuff); SetIndexStyle(1,DRAW_HISTOGRAM);SetIndexDrawBegin(1,Wpr_Period);
  
   SetIndexBuffer(2,blankbuff); SetIndexDrawBegin(2,Wpr_Period);
  
   SetIndexStyle(3,DRAW_LINE);SetIndexBuffer(3,Wprbuff);SetIndexDrawBegin(3,Wpr_Period);
   
   SetIndexBuffer(4,smooth);SetIndexStyle(4,DRAW_LINE);SetIndexDrawBegin(4,Wpr_Period);

         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
   
   IndicatorShortName("Brooky_Wpr_Shade ("+Wpr_Period+")");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
    ObjectDelete("Brooky_Wpr_Shade_ob");
    ObjectDelete("Brooky_Wpr_Shade_os");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{

   int hwnd=WindowHandle(Symbol(),Period());
   int hdc=GetDC(hwnd);
   color back_ground=GetPixel(hdc,1,2);
   ReleaseDC(hwnd,hdc);
   SetIndexStyle(2,DRAW_HISTOGRAM,0,EMPTY,back_ground);
      //
      //
      //
      //
      //
      
      int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { obbuff[0] = MathMin(limit+1,Bars-1); return(0); }
           if (timeFrame!=Period())
           {
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
               for(int i=limit; i>=0; i--)
               {
                  int y = iBarShift(NULL,timeFrame,Time[i]);
                     obbuff[i]    = iCustom(NULL,timeFrame,indicatorFileName,"","","","","",Wpr_Period,OBought,OSold,Smooth_Period,colors,oblevel,oslevel,0,y);
                     osbuff[i]    = iCustom(NULL,timeFrame,indicatorFileName,"","","","","",Wpr_Period,OBought,OSold,Smooth_Period,colors,oblevel,oslevel,1,y);
                     blankbuff[i] = iCustom(NULL,timeFrame,indicatorFileName,"","","","","",Wpr_Period,OBought,OSold,Smooth_Period,colors,oblevel,oslevel,2,y);
                     Wprbuff[i]   = iCustom(NULL,timeFrame,indicatorFileName,"","","","","",Wpr_Period,OBought,OSold,Smooth_Period,colors,oblevel,oslevel,3,y);
                     smooth[i]    = iCustom(NULL,timeFrame,indicatorFileName,"","","","","",Wpr_Period,OBought,OSold,Smooth_Period,colors,oblevel,oslevel,4,y);
               }
               return(0);
           }    


     double wprnow;
     
  //---- main loop
     for(i=0; i<limit; i++)
       {
       obbuff[i]   =EMPTY_VALUE;
       osbuff[i]   =EMPTY_VALUE;
       blankbuff[i]=EMPTY_VALUE;
       
       wprnow=iWPR(NULL,0,Wpr_Period,i);
        
       Wprbuff[i]=wprnow;
       
       if(wprnow<=OSold)
              {
                obbuff[i]   =EMPTY_VALUE;
                osbuff[i]   =wprnow;
                blankbuff[i]=OSold;
              }
       if(wprnow>=OBought)
              {
                obbuff[i]   =OBought;
                osbuff[i]   =EMPTY_VALUE;
                blankbuff[i]=wprnow;
              }
       string obline = "Brooky_Wpr_Shade_ob";
              int windowIndex=WindowFind("Brooky_Wpr_Shade ("+Wpr_Period+")");
              ObjectDelete(obline+i);
              ObjectCreate(obline, OBJ_HLINE, windowIndex, Time[i],OBought);
              ObjectSet(obline, OBJPROP_STYLE, 1);
              ObjectSet(obline, OBJPROP_COLOR,oblevel);       
       string osline = "Brooky_Wpr_Shade_os";
              int windowIndex2=WindowFind("Brooky_Wpr_Shade ("+Wpr_Period+")");
              ObjectDelete(osline+i);
              ObjectCreate(osline, OBJ_HLINE, windowIndex2, Time[i],OSold);
              ObjectSet(osline, OBJPROP_STYLE, 1);
              ObjectSet(osline, OBJPROP_COLOR,oslevel);        
       }
     for(i=0; i<limit; i++)
       {
       smooth[i]=iMAOnArray(Wprbuff,0,Smooth_Period,0,MODE_EMA,i);
       }
       
  //---- done
     return(0);
    }
//+------------------------------------------------------------------+

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
         if (StringToInteger(tfs) == 0) return(Period());
                                        return(StringToInteger(tfs));
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}